"use strict";

function View() {
	let model = null
	let audiocontext = new (window.AudioContext || window.webkitAudioContext)();
	let canvas = null
	let ctx = null
	let canvas_downscale1 = null
	let ctx_downscale1 = null
	let canvas_downscale2 = null
	let ctx_downscale2 = null
	let scale = 0
	let native_width = 5120
	let native_height = 2880
	let asset_unloaded = 11
	let sprite_splash = null
	let sprite_background = null
	let sprite_host = null
	let sprite_host_tint = null
	let sprite_infection = null
	let sprite_sneeze = null
	let sprite_menu = null
	let sprite_menu_buttons = null
	let sprite_menu_font = null
	let sound_theme = null
	let sound_theme_node = null
	let sound_gameover = null
	let sound_gameover_node = null
	let splash_unloaded = true
	let ysort_index = []
	let ysort_value = []
	const hexconv = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F']
	let patch = {
		click_splash: nop,
		click_restart: nop,
		click_button: nop,
		ready: nop
	}
	function nop() {
	}
	requestAnimationFrame(init)
	function init() {
		let img_cache = document.createElement('div')
		let img_cache_container = window.document.createElement('div')
		img_cache_container.appendChild(img_cache)
		img_cache_container.style.position = 'absolute'
		img_cache_container.style.overflow = 'hidden'
		img_cache_container.style.width = '1px'
		img_cache_container.style.height = '1px'
		img_cache.style.position = 'absolute'
		img_cache.style.overflow = 'hidden'
		img_cache.style.width = '1px'
		img_cache.style.height = '1px'
		img_cache.style.top = '-5px'
		window.document.body.appendChild(img_cache_container)
		canvas = document.createElement('canvas')
		canvas.addEventListener('click', function(e) {
			if (!model) {
				patch.click_splash()
				return
			}
			let w = canvas.offsetWidth, h = canvas.offsetHeight, x, y
			if (!w || !h) {
				return
			}
			if (e.pageX || e.pageY) {
				x = e.pageX
				y = e.pageY
			}
			else {
				x = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft
				y = e.clientY + document.body.scrollTop + document.documentElement.scrollTop
			}
			x -= canvas.offsetLeft
			y -= canvas.offsetTop
			x *= native_width/w
			y *= native_height/h
			if (y >= 2408 && y <= 2808) {
				if (x >= 784 && x <= 1184) {
					patch.click_button(0)
				}
				if (x >= 1244 && x <= 1644) {
					patch.click_button(1)
				}
				if (x >= 1704 && x <= 2104) {
					patch.click_button(2)
				}
				if (x >= 2164 && x <= 2564) {
					patch.click_button(3)
				}
				if (x >= 4160 && x <= 4560) {
					patch.click_restart()
				}
			}
		}, false)
		ctx = canvas.getContext('2d')
		canvas_downscale1 = document.createElement('canvas')
		ctx_downscale1 = canvas_downscale1.getContext('2d')
		canvas_downscale2 = document.createElement('canvas')
		ctx_downscale2 = canvas_downscale2.getContext('2d')
		document.body.appendChild(canvas)
		document.body.style.padding = '0'
		document.body.style.margin = '0'
		document.body.style.overflow = 'hidden'
		canvas.width = 0
		window.addEventListener('resize', rescale_canvas, false)
		rescale_canvas()
		sprite_splash = window.document.createElement('img')
		sprite_splash.onload = splash_loaded
		sprite_splash.src = 'assets/img/splash.png'
		img_cache.appendChild(sprite_splash)
		sprite_background = window.document.createElement('img')
		sprite_background.onload = asset_loaded
		sprite_background.src = 'assets/img/background.png'
		img_cache.appendChild(sprite_background)
		sprite_host = window.document.createElement('img')
		sprite_host.onload = asset_loaded
		sprite_host.src = 'assets/img/bunny_spritesheet.png'
		img_cache.appendChild(sprite_host)
		sprite_host_tint = window.document.createElement('img')
		sprite_host_tint.onload = asset_loaded
		sprite_host_tint.src = 'assets/img/bunny_tint_spritesheet.png'
		img_cache.appendChild(sprite_host_tint)
		sprite_infection = window.document.createElement('img')
		sprite_infection.onload = asset_loaded
		sprite_infection.src = 'assets/img/bubbles.png'
		img_cache.appendChild(sprite_infection)
		sprite_sneeze = window.document.createElement('img')
		sprite_sneeze.onload = asset_loaded
		sprite_sneeze.src = 'assets/img/sneeze.png'
		img_cache.appendChild(sprite_sneeze)
		sprite_menu = window.document.createElement('img')
		sprite_menu.onload = asset_loaded
		sprite_menu.src = 'assets/img/ui_background.png'
		img_cache.appendChild(sprite_menu)
		sprite_menu_buttons = window.document.createElement('img')
		sprite_menu_buttons.onload = asset_loaded
		sprite_menu_buttons.src = 'assets/img/button_spritesheet.png'
		img_cache.appendChild(sprite_menu_buttons)
		sprite_menu_font = window.document.createElement('img')
		sprite_menu_font.onload = asset_loaded
		sprite_menu_font.src = 'assets/img/font_spritesheet.png'
		img_cache.appendChild(sprite_menu_font)
		let request_theme = new window.XMLHttpRequest()
		request_theme.open('GET', "assets/snd/theme.wav", true)
		request_theme.responseType = 'arraybuffer'
		request_theme.onload = function() {
			audiocontext.decodeAudioData(request_theme.response, function(buffer) {
				sound_theme = buffer
				asset_loaded()
			})
		}
		request_theme.send()
		let request_gameover = new window.XMLHttpRequest()
		request_gameover.open('GET', "assets/snd/gameover.wav", true)
		request_gameover.responseType = 'arraybuffer'
		request_gameover.onload = function() {
			audiocontext.decodeAudioData(request_gameover.response, function(buffer) {
				sound_gameover = buffer
				asset_loaded()
			})
		}
		request_gameover.send()
	}
	function splash_loaded() {
		splash_unloaded = false
		asset_loaded()
		repaint()
	}
	function asset_loaded() {
		if (!asset_unloaded) {
			return
		}
		asset_unloaded--
		if (asset_unloaded) {
			return
		}
		requestAnimationFrame(animate)
		patch.ready()
	}
	function animate() {
		repaint()
		requestAnimationFrame(animate)
	}
	function rescale_canvas() {
		let width = window.innerWidth
		let height = window.innerHeight
		let left = 0
		let top = 0
		let need_repaint = false
		if (width*native_height > height*native_width) {
			let new_width = (height*native_width/native_height)|0
			left = ((width-new_width)/2)|0
			width = new_width
		}
		else {
			let new_height = (width*native_height/native_width)|0
			top = ((height-new_height)/2)|0
			height = new_height
		}
		if (canvas.width != width || canvas.height != height) {
			canvas.width = width
			canvas.height = height
			need_repaint = true
		}
		canvas.style.marginLeft = left+'px'
		canvas.style.marginTop = top+'px'
		scale = canvas.width/native_width
		if (need_repaint) {
			repaint()
		}
	}
	function update(_model) {
		model = _model
		repaint()
	}
	function repaint() {
		if (!ctx || !scale || splash_unloaded) {
			return
		}
		ctx.fillStyle = '#80ff80'
		ctx.fillRect(0, 0, native_width, native_height)
		ctx.setTransform(scale, 0, 0, scale, 0, 0)
		if (!model || asset_unloaded) {
			if (sound_theme_node) {
				sound_theme_node.stop()
				sound_theme_node.disconnect()
				sound_theme_node = null
			}
			paint_sprite(sprite_splash, 0, 0, 0, 0, 1280, 720, false, 4)
			return
		}
		if (model.restart < 2) {
			if (!sound_theme_node) {
				sound_theme_node = audiocontext.createBufferSource()
				sound_theme_node.buffer = sound_theme;
				sound_theme_node.loop = true
				sound_theme_node.connect(audiocontext.destination)
				sound_theme_node.start()
			}
			if (sound_gameover_node) {
				sound_gameover_node.stop()
				sound_gameover_node.disconnect()
				sound_gameover_node = null
			}
		}
		else {
			if (sound_theme_node) {
				sound_theme_node.stop()
				sound_theme_node.disconnect()
				sound_theme_node = null
			}
			if (!sound_gameover_node) {
				sound_gameover_node = audiocontext.createBufferSource()
				sound_gameover_node.buffer = sound_gameover;
				sound_gameover_node.connect(audiocontext.destination)
				sound_gameover_node.start()
			}
		}
		paint_sprite(sprite_background, 0, 0, 0, 0, 1280, 720, false, 4)
		let time = new Date().getTime()
		let inter_index = 0
		let inter_value = 0
		if (time-model.time > 0) {
			inter_index = 1
			inter_value = time-model.time
			if (inter_value > 100) {
				inter_value = 100
			}
		}
		else {
			inter_value = time+100-model.time
			if (inter_value < 0) {
				inter_value = 0
			}
		}
		while (ysort_index.length < model.hosts.length) {
			ysort_index.push(0)
			ysort_value.push(0)
		}
		for (let i = 0; i < model.hosts.length; i++) {
			let host = model.hosts[i];
			let y = (host.y[inter_index]*(100-inter_value)+host.y[inter_index+1]*inter_value)/100
			ysort_index[i] = i
			ysort_value[i] = y
		}
		for (let i = model.hosts.length; i > 0; ) {
			i--
			for (let j = i; (j<<1)+1 < model.hosts.length; ) {
				let t = (j<<1)+1
				if (t+1 < model.hosts.length && ysort_value[ysort_index[t]] < ysort_value[ysort_index[t+1]]) {
					t++
				}
				if (ysort_value[ysort_index[j]] >= ysort_value[ysort_index[t]]) {
					break
				}
				let s = ysort_index[t]
				ysort_index[t] = ysort_index[j]
				ysort_index[j] = s
				j = t
			}
		}
		for (let i = model.hosts.length-1; i > 0; i--) {
			let s = ysort_index[0]
			ysort_index[0] = ysort_index[i]
			ysort_index[i] = s
			for (let j = 0; (j<<1)+1 < i; ) {
				let t = (j<<1)+1
				if (t+1 < i && ysort_value[ysort_index[t]] < ysort_value[ysort_index[t+1]]) {
					t++
				}
				if (ysort_value[ysort_index[j]] >= ysort_value[ysort_index[t]]) {
					break
				}
				let s = ysort_index[t]
				ysort_index[t] = ysort_index[j]
				ysort_index[j] = s
				j = t
			}
		}
		for (let i = 0; i < model.hosts.length; i++) {
			let host = model.hosts[ysort_index[i]]
			let frame = ((time+i*37) / 25) & 31
			let anim = 0
			let flip = (host.x[inter_index] > host.x[inter_index+1])
			if (host.sneezing > inter_index && host.sneezing < 5+inter_index) {
				frame = ((inter_value+(4+inter_index-host.sneezing)*100) / 25)|0
				if (frame > 15) {
					frame = 15
				}
				anim = 3
				flip = (host.sneezingangle > Math.PI*0.5 || host.sneezingangle < -Math.PI*0.5)
			}
			else if (host.dead+inter_index > 2) {
				frame = ((inter_value+(host.dead+inter_index-3)*100) / 25)|0
				if (frame > 28) {
					frame = 28
				}
				anim = 1
				flip = host.holdflip
			}
			else if (host.kissstart+inter_index > 1 && host.kissend > inter_index) {
				frame = 0
				anim = 2
				flip = host.holdflip
			}
			let x = (host.x[inter_index]*(100-inter_value)+host.x[inter_index+1]*inter_value)/100
			let y = (host.y[inter_index]*(100-inter_value)+host.y[inter_index+1]*inter_value)/100
			ctx.save()
			if (flip) {
				ctx.translate(x, 0)
				ctx.scale(-1, 1)
				ctx.translate(-x, 0)
			}
			var col = host.hp*255/200
			var colstr = hexconv[col>>4]+hexconv[col&0xF]
			paint_sprite(sprite_host_tint, x-330, y, frame*500, anim*440, 500, 440, '#'+colstr+'ff'+colstr)
			paint_sprite(sprite_host, x-330, y, frame*500, anim*440, 500, 440)
			ctx.restore()
			if (host.infected && host.dead+inter_index <= 2) {
				paint_sprite(sprite_infection, x-60, y+30, ((time/25) & 15)*120, 0, 120, 120, '#882d89')
			}
		}
		for (let i = 0; i < model.hosts.length; i++) {
			let host = model.hosts[ysort_index[i]]
			if (!(host.sneezing > inter_index && host.sneezing < 5+inter_index)) {
				continue
			}
			let frame = ((inter_value+(4+inter_index-host.sneezing)*100) / 25)|0
			let x = (host.x[inter_index]*(100-inter_value)+host.x[inter_index+1]*inter_value)/100
			let y = (host.y[inter_index]*(100-inter_value)+host.y[inter_index+1]*inter_value)/100
			let flip = (host.sneezingangle > Math.PI*0.5 || host.sneezingangle < -Math.PI*0.5)
			ctx.save()
			ctx.translate(x+(flip?-70:70), y+200)
			ctx.rotate(host.sneezingangle)
			paint_sprite(sprite_sneeze, 0, -200, frame*800, 0, 800, 400)
			ctx.restore()
		}
		if (model.revive_x[inter_index] != model.revive_x[inter_index+1] || model.revive_y[inter_index] != model.revive_y[inter_index+1]) {
			let x = (model.revive_x[inter_index]*(100-inter_value)+model.revive_x[inter_index+1]*inter_value)/100
			let y = (model.revive_y[inter_index]*(100-inter_value)+model.revive_y[inter_index+1]*inter_value)/100
			paint_sprite(sprite_infection, x-60, y+180, ((time/25) & 15)*120, 0, 120, 120, '#882d89')
		}
		paint_sprite(sprite_menu, 0, 0, 0, 0, 1280, 720, false, 4)
		paint_sprite(sprite_menu_buttons, 784, 2408, model.cankiss*256, 256, 256, 256, false, (25.0/16.0))
		if (model.canturn) {
			if (model.exp < 10000) {
				paint_sprite(sprite_menu_buttons, 1244, 2408, 256, 512, 256, 256, false, (25.0/16.0))
				ctx.save()
				ctx.beginPath()
				ctx.rect(0, 0, native_width, 2768-300*model.exp/10000)
				ctx.clip()
				paint_sprite(sprite_menu_buttons, 1244, 2408, 0, 512, 256, 256, false, (25.0/16.0))
				ctx.restore()
			}
			else {
				paint_sprite(sprite_menu_buttons, 1244, 2408, 512, 512, 256, 256, false, (25.0/16.0))
			}
		}
		else {
			paint_sprite(sprite_menu_buttons, 1244, 2408, 0, 512, 256, 256, false, (25.0/16.0))
		}
		if (model.cansneeze) {
			if (model.exp < 100000) {
				paint_sprite(sprite_menu_buttons, 1704, 2408, 256, 768, 256, 256, false, (25.0/16.0))
				ctx.save()
				ctx.beginPath()
				ctx.rect(0, 0, native_width, 2768-300*model.exp/100000)
				ctx.clip()
				paint_sprite(sprite_menu_buttons, 1704, 2408, 0, 768, 256, 256, false, (25.0/16.0))
				ctx.restore()
			}
			else {
				paint_sprite(sprite_menu_buttons, 1704, 2408, 512, 768, 256, 256, false, (25.0/16.0))
			}
		}
		else {
			paint_sprite(sprite_menu_buttons, 1704, 2408, 0, 768, 256, 256, false, (25.0/16.0))
		}
		if (model.canrevive) {
			if (model.exp < 500000) {
				paint_sprite(sprite_menu_buttons, 2164, 2408, 256, 1024, 256, 256, false, (25.0/16.0))
				ctx.save()
				ctx.beginPath()
				ctx.rect(0, 0, native_width, 2768-300*model.exp/500000)
				ctx.clip()
				paint_sprite(sprite_menu_buttons, 2164, 2408, 0, 1024, 256, 256, false, (25.0/16.0))
				ctx.restore()
			}
			else {
				paint_sprite(sprite_menu_buttons, 2164, 2408, 512, 1024, 256, 256, false, (25.0/16.0))
			}
		}
		else {
			paint_sprite(sprite_menu_buttons, 2164, 2408, 0, 1024, 256, 256, false, (25.0/16.0))
		}
		paint_sprite(sprite_menu_buttons, 4160, 2408, (((time & 0x3ff)>0x200)?(model.restart+1)>>1:model.restart)*256, 0, 256, 256, false, (25.0/16.0))
		let num = (model.exp/1000)|0
		let pos = 0
		let digit = 1
		let digits = 1
		while (digit*10 <= num) {
			digit *= 10
			digits++
		}
		while (digits) {
			let val = (num/digit)|0
			num -= val*digit
			paint_sprite(sprite_menu_font, (pos++)*148+2920, 2650, val*148, 0, 148, 184)
			digit = (digit/10)|0
			digits--
			if (digits && !(digits % 3)) {
				paint_sprite(sprite_menu_font, pos*148+2840, 2650, 12*148, 0, 148, 184)
			}
		}
		num = model.runtime
		pos = 0
		digit = 10
		digits = 2
		if (digit*60 <= num) {
			digit *= 60
			digits += 2
			if (digit*60 <= num) {
				digit *= 60
				digits += 2
				while (digit*10 <= num) {
					digit *= 10
					digits++
				}
			}
			else if (digit*10 <= num) {
				digit *= 10
				digits++
			}
		}
		else if (digit*10 <= num) {
			digit *= 10
			digits++
		}
		while (digits) {
			let val = (num/digit)|0
			num -= val*digit
			paint_sprite(sprite_menu_font, (pos++)*148+2920, 2410, val*148, 0, 148, 184)
			digits--
			if (digits == 3 || digits == 5) {
				digit = (digit/6)|0
				paint_sprite(sprite_menu_font, pos*148+2840, 2410, 10*148, 0, 148, 184)
			}
			else {
				digit = (digit/10)|0
				if (digits == 1) {
					paint_sprite(sprite_menu_font, pos*148+2840, 2410, 11*148, 0, 148, 184)
				}
				else if (digits > 5 && (digits % 3) == 2) {
					paint_sprite(sprite_menu_font, pos*148+2840, 2410, 12*148, 0, 148, 184)
				}
			}
		}
		paint_sprite(sprite_menu, 0, 0, 1280, 0, 1280, 720, false, 4)
	}
	function paint_sprite(sprite, x, y, sx, sy, w, h, tint, scaleup) {
		scaleup = scaleup || 1
		let tw = w*scaleup
		let th = h*scaleup
		let curscale = scale*scaleup
		if (curscale >= 0.5) {
			if (tint) {
				if (canvas_downscale1.width < w || canvas_downscale1.height < h) {
					canvas_downscale1.width = w
					canvas_downscale1.height = h
				}
				ctx_downscale1.clearRect(0, 0, w, h)
				ctx_downscale1.drawImage(sprite, sx, sy, w, h, 0, 0, w, h)
				ctx_downscale1.globalCompositeOperation = 'source-atop';
				ctx_downscale1.fillStyle = tint;
				ctx_downscale1.fillRect(0, 0, canvas.width, canvas.height);
				ctx_downscale1.globalCompositeOperation = 'source-over';
				ctx.drawImage(canvas_downscale1, 0, 0, w, h, x, y, tw, th)
			}
			else {
				ctx.drawImage(sprite, sx, sy, w, h, x, y, tw, th)
			}
			return;
		}
		if (canvas_downscale1.width < w || canvas_downscale1.height < h) {
			canvas_downscale1.width = w
			canvas_downscale1.height = h
			canvas_downscale2.width = w
			canvas_downscale2.height = h
		}
		let sw = w*0.5
		let sh = h*0.5
		ctx_downscale1.clearRect(0, 0, w, h)
		ctx_downscale1.drawImage(sprite, sx, sy, w, h, 0, 0, sw, sh)
		if (tint) {
			ctx_downscale1.globalCompositeOperation = 'source-atop';
			ctx_downscale1.fillStyle = tint;
			ctx_downscale1.fillRect(0, 0, canvas.width, canvas.height);
			ctx_downscale1.globalCompositeOperation = 'source-over';
		}
		curscale *= 2
		if (curscale >= 0.5) {
			ctx.drawImage(canvas_downscale1, 0, 0, sw, sh, x, y, tw, th)
			return
		}
		while (true) {
			sw *= 0.5
			sh *= 0.5
			ctx_downscale2.clearRect(0, 0, w, h)
			ctx_downscale2.drawImage(canvas_downscale1, 0, 0, sw*2, sh*2, 0, 0, sw, sh)
			curscale *= 2
			if (curscale >= 0.5) {
				ctx.drawImage(canvas_downscale2, 0, 0, sw, sh, x, y, tw, th)
				return
			}
			sw *= 0.5
			sh *= 0.5
			ctx_downscale1.clearRect(0, 0, w, h)
			ctx_downscale1.drawImage(canvas_downscale2, 0, 0, sw*2, sh*2, 0, 0, sw, sh)
			curscale *= 2
			if (curscale >= 0.5) {
				ctx.drawImage(canvas_downscale1, 0, 0, sw, sh, x, y, tw, th)
				return
			}
		}
	}
	return {
		update: update,
		patch: patch
	};
}
